<template>
  <Component
    :is="component"
    :class="[
      'v-btn',
      {
        disabled,
        large,
        dark,
      },
    ]"
    v-bind="$attrs"
    :tabindex="ghost ? -1 : 0"
    :aria-disabled="ghost"
    @click.capture="click"
    @click.capture.native="click"
  >
    <div class="content">
      <slot />
    </div>
  </Component>
</template>

<script lang="ts">
import {
  Component, Vue, Prop, Emit,
} from 'nuxt-property-decorator';

@Component({
  inheritAttrs: false,
})
export default class VBtn extends Vue {
  @Prop(Boolean)
  readonly outline!: boolean

  @Prop(Boolean)
  readonly disabled!: boolean

  @Prop(Boolean)
  readonly loading!: boolean

  @Prop(Boolean)
  readonly large!: boolean

  @Prop(Boolean)
  readonly dark!: boolean

  get component() {
    if (this.$attrs.to) return 'router-link';
    if (this.$attrs.href) return 'a';
    return 'button';
  }

  get ghost() {
    return this.disabled || this.loading;
  }

  @Emit()
  private click(e: MouseEvent) {
    if (this.ghost) {
      e.preventDefault();
      e.stopPropagation();
    }
  }
}
</script>

<style lang="stylus">
.v-btn
  position relative
  flex 0 1 auto
  display inline-flex
  vertical-align middle
  align-items center
  justify-content center
  cursor pointer
  min-width 88px
  height 32px
  margin 6px 8px
  padding 0
  font-size 14px
  font-weight 500
  text-decoration none
  outline 0
  user-select none
  background-color #fafafa
  color rgba(black, .87)
  border 1px solid #dcdfe6
  border-radius 4px
  transition background .1s, color .1s
  > .content
    display flex
    flex 1 0 auto
    align-items center
    justify-content center
    height 100%
    margin 0 auto
    padding 0 14px
    border-radius inherit
    color inherit
    white-space nowrap
  &:hover
    background-color rgba(226, 226, 226, .9844)
  &:active
    background-color rgba(184, 184, 184, .9584)
  &.large
    font-size 16px
    height 44px
  &.dark
    background-color #6c757d
    color white
    &:hover
      background-color #5a6268
    &:active
      background-color #343a40
</style>
